Index: trunk/src/lib/collision_detection/cd_engine.cc
===================================================================
--- trunk/src/lib/collision_detection/cd_engine.cc	(revision 8450)
+++ trunk/src/lib/collision_detection/cd_engine.cc	(revision 8490)
@@ -20,4 +20,6 @@
 #include "debug.h"
 
+#include "class_list.h"
+
 #include "model.h"
 #include "world_entity.h"
@@ -30,4 +32,5 @@
 
 #include "bsp_manager.h"
+#include "bsp_entity.h"
 
 using namespace std;
@@ -97,21 +100,18 @@
 void CDEngine::checkCollisionGround(std::list<WorldEntity*>& list1)
 {
-  if( likely( this->terrain != NULL))
-  {
-//    Quadtree* q = dynamic_cast<Terrain*>(this->terrain)->ssp->getQuadtree();
-//    QuadtreeNode* n = q->getQuadtreeFromPosition(this->player->getAbsCoor());
-  }
 
-  if( likely( this->bspManager != NULL))
-  {
-    std::list<WorldEntity*>::iterator iterator;
-    PRINTF(3)("checking for collisions\n");
+  std::list<BaseObject*>::const_iterator bspIterator;
+  std::list<WorldEntity*>::iterator entityIterator;
+  const std::list<BaseObject*>* bspList = ClassList::getList(CL_BSP_ENTITY);
+  if( bspList == NULL)
+    return;
 
-    iterator = list1.begin();
-    while (iterator != list1.end())
-    {
-      bspManager->checkCollision(*iterator);
-      iterator++;
-    }
+  // for all bsp managers check all entities
+  for( bspIterator = bspList->begin(); bspIterator != bspList->end(); bspIterator++) {
+      for(entityIterator = list1.begin(); entityIterator != list1.end(); entityIterator++)
+      {
+//         PRINTF(0)("Checking: %s a %s\n", (*entityIterator)->getName(), (*entityIterator)->getClassName());
+        (dynamic_cast<BspEntity*>(*bspIterator)->getBspManager())->checkCollision(*entityIterator);
+      }
   }
 }
@@ -128,5 +128,4 @@
   PRINT(0)("=  CDEngine: Spawning Tree: Finished\n");
   PRINT(0)("=======================================================\n");
-
 }
 
@@ -149,4 +148,5 @@
 }
 
+
 /**
  * this draws the debug spawn tree
Index: trunk/src/lib/collision_reaction/Makefile.am
===================================================================
--- trunk/src/lib/collision_reaction/Makefile.am	(revision 8450)
+++ trunk/src/lib/collision_reaction/Makefile.am	(revision 8490)
@@ -9,5 +9,6 @@
                      collision_handle.cc \
                      collision_reaction.cc \
-                     cr_object_damage.cc
+                     cr_object_damage.cc \
+                     cr_physics_ground_walk.cc
 
 
@@ -19,4 +20,5 @@
                      cr_defs.h \
                      collision_reaction.h \
-                     cr_object_damage.h
+                     cr_object_damage.h \
+                     cr_physics_ground_walk.h
 
Index: trunk/src/lib/collision_reaction/collision.h
===================================================================
--- trunk/src/lib/collision_reaction/collision.h	(revision 8450)
+++ trunk/src/lib/collision_reaction/collision.h	(revision 8490)
@@ -27,5 +27,5 @@
 
     /** collides two WorldEntities @param entityA world entity A, @param entityB world entity B, @param bvA volume A @param bvB volumeB */
-    inline void collide(WorldEntity* entityA, WorldEntity* entityB) { this->entityA = entityA; this->entityB = entityB; }
+    inline void collide(WorldEntity* entityA, WorldEntity* entityB) { this->entityA = entityA; this->entityB = entityB; this->bDispatched = false; }
 
 
@@ -42,4 +42,5 @@
     /** sets the flag if it reacts @param flag true if it should react on entityB*/
     inline void setEntityBCollide(bool flag) { this->entityACollide = flag; }
+
 
     /** @returns true if this Collision has already been dispatched */
Index: trunk/src/lib/collision_reaction/collision_event.h
===================================================================
--- trunk/src/lib/collision_reaction/collision_event.h	(revision 8450)
+++ trunk/src/lib/collision_reaction/collision_event.h	(revision 8490)
@@ -25,6 +25,6 @@
   { this->entityA = entityA; this->entityB = entityB; this->bvA = bvA; this->bvB = bvB; }
   /** collides two WorldEntities @param entity world entity , @param ground ground plane, @param position position on the ground */
-  inline void collide(WorldEntity* entity, Plane* ground, Vector position)
-  { this->entityA = entity; this->ground = ground; this->position = position; }
+  inline void collide(WorldEntity* entity, WorldEntity* groundEntity, Vector normal, Vector position)
+  { this->entityA = entity; this->entityB = groundEntity, this->groundNormal = normal; this->position = position; }
 
 
@@ -38,8 +38,9 @@
   inline BoundingVolume* getBVB() const { return this->bvB; }
 
+  /** @return ground plane if collided with bsp model */
+  inline Vector getGroundNormal() { return this->groundNormal; }
 
-  inline void operator()(WorldEntity* entityA, WorldEntity* entityB, BoundingVolume* bvA, BoundingVolume* bvB) { this->collide(entityA, entityB, bvA, bvB); }
-  inline void operator()(WorldEntity* entity, Plane* ground, Vector position) { this->collide(entity, ground, position); }
-
+  /** @return position of the position, only accurate if this is a collision with the ground!!! */
+  inline Vector getCollisionPosition() { return this->position; }
 
  private:
@@ -50,5 +51,5 @@
   BoundingVolume*   bvB;                           //!< reference to the bounding volume B
 
-  Plane*            ground;                        //!< the ground plane with which it collides (only for bsp-model collisions
+  Vector            groundNormal;                  //!< the ground plane with which it collides (only for bsp-model collisions
   Vector            position;                      //!< position of the collision on the ground plane
 };
Index: trunk/src/lib/collision_reaction/collision_handle.cc
===================================================================
--- trunk/src/lib/collision_reaction/collision_handle.cc	(revision 8450)
+++ trunk/src/lib/collision_reaction/collision_handle.cc	(revision 8490)
@@ -24,4 +24,5 @@
 
 #include "cr_object_damage.h"
+#include "cr_physics_ground_walk.h"
 
 #include "debug.h"
@@ -42,20 +43,24 @@
 
   this->bCollided = false;
-  this->bDispatched = false;
-
-  if( this->type == CREngine::CR_PHYSICS_STEP_BACK)
-    this->bContinuousPoll = false;
-  else
-    this->bContinuousPoll = true;
-
-  if( this->type == CREngine::CR_OBJECT_DAMAGE)
-    this->bStopOnFirstCollision = true;
-  else
-   this->bStopOnFirstCollision = false;
+  this->bDispatched = true;
+
+  this->collisionReaction = NULL;
+  this->bContinuousPoll = false;
+  this->bStopOnFirstCollision = false;
+
 
   switch( type)
   {
+    case CREngine::CR_PHYSICS_STEP_BACK:
+//       this->collisionReaction = new CRPhysicsGroundWalk();
+      this->bContinuousPoll = true;
+      break;
+    case CREngine::CR_PHYSICS_GROUND_WALK:
+      this->collisionReaction = new CRPhysicsGroundWalk();
+      this->bContinuousPoll = true;
+      break;
     case CREngine::CR_OBJECT_DAMAGE:
       this->collisionReaction = new CRObjectDamage();
+      this->bStopOnFirstCollision = true;
       break;
     default:
@@ -71,4 +76,6 @@
 {
   // delete what has to be deleted here
+  if( this->collisionReaction != NULL)
+    delete this->collisionReaction;
 }
 
@@ -169,4 +176,5 @@
 
  c->registerCollisionEvent(collisionEvent);
+ PRINTF(0)("Registering Collision Event: %s, %s\n", collisionEvent->getEntityA()->getClassName(), collisionEvent->getEntityB()->getClassName());
 }
 
@@ -186,4 +194,11 @@
 void CollisionHandle::handleCollisions()
 {
+  // if continuous poll poll the reaction
+  if( this->bContinuousPoll && !this->bCollided)
+  {
+    this->collisionReaction->update(this->owner);
+    return;
+  }
+
   // collision reaction calculations (for every collision there will be a reaction)
   vector<Collision*>::iterator it = this->collisionList.begin();
@@ -214,9 +229,15 @@
   {
     if( collisionEvent->getEntityA() == this->owner) {
-      if( collisionEvent->getEntityA()->isA((ClassID)(*it)))
+      if( collisionEvent->getEntityB()->isA((ClassID)(*it))) {
+        PRINTF(0)("I am: %s colliding with: %s is a %i filter ok\n", owner->getClassName(),
+                  collisionEvent->getEntityB()->getClassName(), *it);
         return true; }
+    }
     else {
-      if( collisionEvent->getEntityB()->isA((ClassID)(*it)))
-        return true; }
+      if( collisionEvent->getEntityA()->isA((ClassID)(*it))) {
+        PRINTF(0)("I am: %s colliding with: %s is a %i filter ok\n", owner->getClassName(),
+                  collisionEvent->getEntityA()->getClassName(), *it);
+      return true; }
+    }
   }
 
Index: trunk/src/lib/collision_reaction/collision_handle.h
===================================================================
--- trunk/src/lib/collision_reaction/collision_handle.h	(revision 8450)
+++ trunk/src/lib/collision_reaction/collision_handle.h	(revision 8490)
@@ -41,4 +41,6 @@
     /** @returns true if this handle should be pulled also if there are no collisions */
     inline bool isContinuousPoll() const { return this->bContinuousPoll; }
+    /** @returns the type */
+    inline CREngine::CRType getType() const { return this->type; }
 
     void handleCollisions();
Index: trunk/src/lib/collision_reaction/collision_reaction.h
===================================================================
--- trunk/src/lib/collision_reaction/collision_reaction.h	(revision 8450)
+++ trunk/src/lib/collision_reaction/collision_reaction.h	(revision 8490)
@@ -12,4 +12,6 @@
 
 class Collision;
+class WorldEntity;
+
 
 //! A class representing a simple collision
@@ -23,4 +25,7 @@
     virtual void reactToCollision(Collision* collision) = 0;
 
+    virtual void update(WorldEntity* owner) {}
+
+    /** use this to do some collision offline calculations, only called for bContinuousPoll == true */
     inline bool isContinuousPoll() const { return this->bContinuousPoll; }
 
Index: trunk/src/lib/collision_reaction/cr_engine.cc
===================================================================
--- trunk/src/lib/collision_reaction/cr_engine.cc	(revision 8450)
+++ trunk/src/lib/collision_reaction/cr_engine.cc	(revision 8490)
@@ -126,8 +126,6 @@
 {
   std::vector<CollisionHandle*>::iterator it;
-  for( it = this->collisionHandles.begin(); it != this->collisionHandles.end(); it++)
-  {
-    if( *it == collisionHandle)
-    {
+  for( it = this->collisionHandles.begin(); it != this->collisionHandles.end(); it++)  {
+    if( *it == collisionHandle) {
       this->collisionHandles.erase(it);
       delete collisionHandle;
@@ -147,5 +145,5 @@
   for( it = this->collisionHandles.begin(); it != this->collisionHandles.end(); it++)
   {
-    if( (*it)->isCollided() || (*it)->isContinuousPoll())  //does it have any collisions to report at all
+    if( !(*it)->isDispatched() || (*it)->isContinuousPoll())  //does it have any collisions to report at all
     {
       (*it)->handleCollisions();
Index: trunk/src/lib/collision_reaction/cr_object_damage.cc
===================================================================
--- trunk/src/lib/collision_reaction/cr_object_damage.cc	(revision 8450)
+++ trunk/src/lib/collision_reaction/cr_object_damage.cc	(revision 8490)
@@ -54,7 +54,7 @@
 void CRObjectDamage::reactToCollision(Collision* collision)
 {
-  float damage;
+  float damage = 0.0f;
 
-  PRINTF(0)("Dealing damage - Handling collision: %s vs %s\n",
+  PRINTF(4)("Dealing damage - Handling collision: %s vs %s\n",
             collision->getEntityA()->getClassName(),
             collision->getEntityB()->getClassName());
@@ -65,5 +65,5 @@
     collision->getEntityA()->decreaseHealth(damage);
   }
-  PRINTF(0)("Dealing damage - %f damage to %s \n", damage, collision->getEntityA()->getClassName());
+  PRINTF(4)("Dealing damage - %f damage to %s \n", damage, collision->getEntityA()->getClassName());
 
   if( collision->isEntityBCollide()) {
@@ -71,5 +71,5 @@
     collision->getEntityB()->decreaseHealth(damage);
   }
-  PRINTF(0)("Dealing damage - %f damage to %s \n", damage, collision->getEntityB()->getClassName());
+  PRINTF(4)("Dealing damage - %f damage to %s \n", damage, collision->getEntityB()->getClassName());
 
   collision->flushCollisionEvents();
Index: trunk/src/lib/collision_reaction/cr_physics_ground_walk.cc
===================================================================
--- trunk/src/lib/collision_reaction/cr_physics_ground_walk.cc	(revision 8490)
+++ trunk/src/lib/collision_reaction/cr_physics_ground_walk.cc	(revision 8490)
@@ -0,0 +1,88 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Patrick Boenzli
+   co-programmer: ...
+*/
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_COLLISION_REACTION
+
+#include "collision.h"
+#include "collision_event.h"
+
+#include "physics_interface.h"
+
+#include "world_entity.h"
+#include "cr_physics_ground_walk.h"
+
+#include "debug.h"
+
+#include <vector>
+
+using namespace std;
+
+
+/**
+ *  standard constructor
+ */
+CRPhysicsGroundWalk::CRPhysicsGroundWalk ()
+  : CollisionReaction()
+{
+  this->setClassID(CL_CR_PHYSICS_GROUND_WALK, "CRPhysicsGroundWalk");
+}
+
+
+/**
+ *  standard deconstructor
+ */
+CRPhysicsGroundWalk::~CRPhysicsGroundWalk ()
+{
+}
+
+
+/**
+ * caluculates and applys the reaction to a specific collision
+ *  @param collision the collision
+ */
+void CRPhysicsGroundWalk::reactToCollision(Collision* collision)
+{
+  CollisionEvent* ce = collision->getCollisionEvents().front();
+  Vector normal = ce->getGroundNormal();
+  normal.normalize();
+
+  // put it back
+//   PRINTF(0)("putting it back to lastPos: \n");
+//   this->lastPositions[0].debug();
+//   PRINTF(0)("current pos:\n");
+//   collision->getEntityB()->getAbsCoor().debug();
+
+  PRINTF(0)("Collision with Ground: \n");
+  collision->getEntityB()->getAbsCoor().debug();
+
+  //collision->getEntityB()->setVelocity(Vector());
+  //collision->getEntityB()->setAbsCoor(this->lastPositions[5]);
+}
+
+
+
+/**
+ * use this to do some collision offline calculations, only called for bContinuousPoll == true
+ */
+void CRPhysicsGroundWalk::update(WorldEntity* owner)
+{
+  for( int i = 9; i > 0; i--) {
+    this->lastPositions[i] = this->lastPositions[i-1];
+//     PRINTF(0)("lastPosition[%i]: %f, %f, %f\n", i, lastPositions[i].x, lastPositions[i].y, lastPositions[i].z);
+  }
+  this->lastPositions[0] = owner->getAbsCoor();
+}
+
+
Index: trunk/src/lib/collision_reaction/cr_physics_ground_walk.h
===================================================================
--- trunk/src/lib/collision_reaction/cr_physics_ground_walk.h	(revision 8490)
+++ trunk/src/lib/collision_reaction/cr_physics_ground_walk.h	(revision 8490)
@@ -0,0 +1,33 @@
+/*!
+ * @file cr_object_damage.h
+ *  Definition of a collision reaction: dealing damage to an object
+ */
+
+#ifndef _CR_PHYSICS_GROUND_WALK_H
+#define _CR_PHYSICS_GROUND_WALK_H
+
+#include "collision_reaction.h"
+
+
+class Collision;
+
+//! A class representing a reaction to a collision: dealing damage to an object
+class CRPhysicsGroundWalk : public CollisionReaction
+{
+  public:
+    CRPhysicsGroundWalk();
+    virtual ~CRPhysicsGroundWalk();
+
+    virtual void reactToCollision(Collision* collision);
+
+    virtual void update(WorldEntity* entity);
+
+  private:
+    Vector       lastPosition;                //!< vector with the last valid position
+    Vector       afterLastPosition;           //!< vector for the after last
+    Quaternion   lastDirection;               //!< quat with the last valid direction
+
+    Vector       lastPositions[10];           //!< last 10 positions
+};
+
+#endif /* _CR_PHYSICS_GROUND_WALK_H */
Index: trunk/src/lib/coord/p_node.h
===================================================================
--- trunk/src/lib/coord/p_node.h	(revision 8450)
+++ trunk/src/lib/coord/p_node.h	(revision 8490)
@@ -103,4 +103,6 @@
   /** @returns the absolute position */
   inline const Vector& getAbsCoor () const { return this->absCoordinate; };
+  /** @returns the absolute position */
+  inline const Vector& getLastAbsCoor () const { return this->lastAbsCoordinate; };
   void shiftCoor (const Vector& shift);
   void shiftCoor (float x, float y, float z) { this->shiftCoor(Vector(x, y, z)); };
@@ -238,5 +240,5 @@
     float roty;
     float rotz;
-    
+
   private:
     int relCoordinate_handle;
@@ -244,5 +246,5 @@
     Vector relCoordinate_write;
     Quaternion relDirection_write;
-    
+
   public:
     virtual void varChangeHandler( std::list<int> & id );
Index: trunk/src/lib/event/event_handler.cc
===================================================================
--- trunk/src/lib/event/event_handler.cc	(revision 8450)
+++ trunk/src/lib/event/event_handler.cc	(revision 8490)
@@ -355,5 +355,5 @@
   else
   {
-//    SDL_WM_GrabInput(SDL_GRAB_ON);
+    SDL_WM_GrabInput(SDL_GRAB_ON);
     SDL_ShowCursor(SDL_DISABLE);
   }
Index: trunk/src/lib/graphics/graphics_engine.cc
===================================================================
--- trunk/src/lib/graphics/graphics_engine.cc	(revision 8450)
+++ trunk/src/lib/graphics/graphics_engine.cc	(revision 8490)
@@ -66,4 +66,5 @@
 
   this->bDisplayFPS = false;
+  this->bAntialiasing = false;
   this->minFPS = 9999;
   this->maxFPS = 0;
@@ -283,9 +284,16 @@
   SDL_GL_SetAttribute( SDL_GL_ACCUM_ALPHA_SIZE, 0);
 
-  SDL_GL_SetAttribute(SDL_GL_RED_SIZE, 5);	//Use at least 5 bits of Red
-  SDL_GL_SetAttribute(SDL_GL_GREEN_SIZE, 5);	//Use at least 5 bits of Green
-  SDL_GL_SetAttribute(SDL_GL_BLUE_SIZE, 5);	//Use at least 5 bits of Blue
-  SDL_GL_SetAttribute(SDL_GL_DEPTH_SIZE, 16);	//Use at least 16 bits for the depth buffer
+  SDL_GL_SetAttribute(SDL_GL_RED_SIZE, 5);      //Use at least 5 bits of Red
+  SDL_GL_SetAttribute(SDL_GL_GREEN_SIZE, 5);    //Use at least 5 bits of Green
+  SDL_GL_SetAttribute(SDL_GL_BLUE_SIZE, 5);     //Use at least 5 bits of Blue
+  SDL_GL_SetAttribute(SDL_GL_DEPTH_SIZE, 16);   //Use at least 16 bits for the depth buffer
   SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER, 1);  //Enable double buffering
+
+  // enable antialiasing?
+  if( this->bAntialiasing)
+  {
+    SDL_GL_SetAttribute(SDL_GL_MULTISAMPLESAMPLES,4);
+    SDL_GL_SetAttribute(SDL_GL_MULTISAMPLEBUFFERS,1);
+  }
 
   glEnable(GL_CULL_FACE);
Index: trunk/src/lib/graphics/graphics_engine.h
===================================================================
--- trunk/src/lib/graphics/graphics_engine.h	(revision 8450)
+++ trunk/src/lib/graphics/graphics_engine.h	(revision 8490)
@@ -46,4 +46,6 @@
     static void setBackgroundColor(GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha = 1.0);
 
+    inline void setAntialiasing(bool flag) { this->bAntialiasing = flag; }
+    inline bool getAntialiasing() { return this->bAntialiasing; }
 
     /** @returns the x resolution */
@@ -109,4 +111,6 @@
     bool                       shadowsEnabled;     //!< If Shadows should be enabled.
     bool                       particlesEnabled;   //!< If particles should be enabled.
+    bool                       bAntialiasing;      //!< true if antialiasing enabled
+
     int                        particlesValue;     //!< How many particles
     int                        textureQuality;     //!< the quality of Textures
Index: trunk/src/lib/graphics/importer/Makefile.am
===================================================================
--- trunk/src/lib/graphics/importer/Makefile.am	(revision 8450)
+++ trunk/src/lib/graphics/importer/Makefile.am	(revision 8490)
@@ -5,4 +5,6 @@
 
 libORXimporter_a_SOURCES = model.cc \
+			   interactive_model.cc \
+			   md_model_structure.cc \
                            vertex_array_model.cc \
                            grid.cc \
@@ -10,5 +12,4 @@
                            objModel.cc \
                            primitive_model.cc \
-                           md2Model.cc \
                            height_map.cc \
                            bsp_manager.cc \
@@ -22,5 +23,19 @@
                            texture_sequence.cc \
                            media_container.cc \
-                           movie_player.cc
+                           movie_player.cc \
+                           \
+                           bsp_manager.cc \
+                           bsp_file.cc \
+                           bsp_tree_node.cc \
+                           bsp_tree_leaf.cc \
+                           \
+                           md2/md2Model.cc \
+                           \
+                           md3/md3_model.cc \
+                           md3/md3_animation.cc \
+                           md3/md3_bone_frame.cc \
+                           md3/md3_mesh.cc \
+                           md3/md3_data.cc \
+                           md3/md3_tag.cc
 
 
@@ -32,4 +47,6 @@
 noinst_HEADERS = \
 		model.h \
+		interactive_model.h \
+		md_model_structure.cc \
 		tc.h \
 		vertex_array_model.h \
@@ -38,5 +55,4 @@
 		objModel.h \
 		primitive_model.h \
-		md2Model.h \
 		anorms.h \
 		anormtab.h \
@@ -54,3 +70,13 @@
 		bsp_file.h \
 		bsp_tree_node.h \
-		bsp_tree_leaf.h
+		bsp_tree_leaf.h \
+		\
+                md2/md2Model.h \
+                \
+                md3/md3_model.h \
+                md3/md3_animation.h \
+                md3/md3_bone_frame.h \
+                md3/md3_mesh.h \
+                md3/md3_data.h \
+                md3/md3_tag.h
+
Index: trunk/src/lib/graphics/importer/bsp_file.cc
===================================================================
--- trunk/src/lib/graphics/importer/bsp_file.cc	(revision 8450)
+++ trunk/src/lib/graphics/importer/bsp_file.cc	(revision 8490)
@@ -37,4 +37,7 @@
 #include <SDL/SDL_image.h>
 
+// STL Containers
+#include <vector>
+
 using namespace std;
 
@@ -50,5 +53,5 @@
 int BspFile::read(const char* name)
 {
-  //this->scale = 0.4;
+  this->scale = 1.0;
   int offset;
   int size;
@@ -211,8 +214,8 @@
     bspFile.read(this->visData, size);
 
-    PRINTF(4)("BSP FILE: VisDataSize: %i Bytes. \n", size);
-    PRINTF(4)("BSP FILE: NumVisData: %i. \n", size /1 - 8);
-    PRINTF(4)("BSP FILE: Remainder: %i. \n", size % 1);
-    PRINTF(4)("BSP FILE: VisDataOffset: %i. \n", offset);
+    PRINTF(0)("BSP FILE: VisDataSize: %i Bytes. \n", size);
+    PRINTF(0)("BSP FILE: NumVisData: %i. \n", size /1 - 8);
+    PRINTF(0)("BSP FILE: Remainder: %i. \n", size % 1);
+    PRINTF(0)("BSP FILE: VisDataOffset: %i. \n", offset);
 
     // Get the Textures
@@ -388,6 +391,8 @@
 {
   ::std::string absFileName;
-  char fileName [228];
-  char ext [100];
+  char* baseName = "/worlds/bsp/";
+
+  char fileName [500];
+  char ext [500];
   struct stat results;
 
@@ -401,6 +406,7 @@
     if(strlen(fileName) == 0)
     {
+
      //         Default Material
-      this->Materials[i].mat = new Material();
+    this->Materials[i].mat = new Material();
     this->Materials[i].mat->setDiffuse(0.1,0.1,1.0);
     this->Materials[i].mat->setAmbient(0.1,0.1,1.0 );
@@ -417,7 +423,11 @@
 
       // Check for mov
-    strcpy(fileName, &this->textures[8+ 72*i]);
+    strcpy(fileName, baseName);
+    strcpy(ext, &this->textures[8+ 72*i]);
+    strncat(fileName, ext, strlen(fileName) + strlen(&this->textures[8+ 72*i]) );
     strcpy(ext, ".mov");
-    strncat (fileName, ext, strlen(fileName));
+    strncat (fileName, ext, strlen(fileName) );
+
+    PRINTF(0)("BSP FILE: Name %s . \n", fileName);
 
     absFileName = ResourceManager::getFullName(fileName);
@@ -430,5 +440,7 @@
 
     // Check for avi
-    strcpy(fileName, &this->textures[8+ 72*i]);
+    strcpy(fileName, baseName);
+    strcpy(ext, &this->textures[8+ 72*i]);
+    strncat(fileName, ext, strlen(fileName) + strlen(&this->textures[8+ 72*i]) );
     strcpy(ext, ".avi");
     strncat (fileName, ext, strlen(fileName));
@@ -443,5 +455,7 @@
 
        // Check for mpg
-    strcpy(fileName, &this->textures[8+ 72*i]);
+    strcpy(fileName, baseName);
+    strcpy(ext, &this->textures[8+ 72*i]);
+    strncat(fileName, ext, strlen(fileName) + strlen(&this->textures[8+ 72*i]) );
     strcpy(ext, ".mpg");
     strncat (fileName, ext, strlen(fileName));
@@ -456,5 +470,7 @@
 
     // Check for tga
-    strcpy(fileName, &this->textures[8+ 72*i]);
+    strcpy(fileName, baseName);
+    strcpy(ext, &this->textures[8+ 72*i]);
+    strncat(fileName, ext, strlen(fileName) + strlen(&this->textures[8+ 72*i]) );
     strcpy(ext, ".tga");
     strncat (fileName, ext, strlen(fileName));
@@ -468,5 +484,7 @@
     }
     // Check for TGA
-    strcpy(fileName, &this->textures[8+ 72*i]);
+    strcpy(fileName, baseName);
+    strcpy(ext, &this->textures[8+ 72*i]);
+    strncat(fileName, ext, strlen(fileName) + strlen(&this->textures[8+ 72*i]) );
     strcpy(ext, ".TGA");
     strncat (fileName, ext, strlen(fileName));
@@ -479,5 +497,7 @@
     }
     // Check for jpg
-    strcpy(fileName, &this->textures[8+ 72*i]);
+    strcpy(fileName, baseName);
+    strcpy(ext, &this->textures[8+ 72*i]);
+    strncat(fileName, ext, strlen(fileName) + strlen(&this->textures[8+ 72*i]) );
     strcpy(ext, ".jpg");
     strncat (fileName, ext, strlen(fileName));
@@ -491,5 +511,7 @@
 
     // Check for JPG
-    strcpy(fileName, &this->textures[8+ 72*i]);
+    strcpy(fileName, baseName);
+    strcpy(ext, &this->textures[8+ 72*i]);
+    strncat(fileName, ext, strlen(fileName) + strlen(&this->textures[8+ 72*i]) );
     strcpy(ext, ".JPG");
     strncat (fileName, ext, strlen(fileName));
@@ -504,5 +526,7 @@
 
     // Check for bmp
-    strcpy(fileName, &this->textures[8+ 72*i]);
+    strcpy(fileName, baseName);
+    strcpy(ext, &this->textures[8+ 72*i]);
+    strncat(fileName, ext, strlen(fileName) + strlen(&this->textures[8+ 72*i]) );
     strcpy(ext, ".bmp");
     strncat (fileName, ext, strlen(fileName));
@@ -516,5 +540,7 @@
 
     // Check for BMP
-    strcpy(fileName, &this->textures[8+ 72*i]);
+    strcpy(fileName, baseName);
+    strcpy(ext, &this->textures[8+ 72*i]);
+    strncat(fileName, ext, strlen(fileName) + strlen(&this->textures[8+ 72*i]) );
     strcpy(ext, ".BMP");
     strncat (fileName, ext, strlen(fileName));
@@ -577,4 +603,6 @@
   MoviePlayer * testMC = new MoviePlayer(mat);
   testMC->start(0);
+  
+  this->MovieMaterials.push_back(testMC);
 
   //Material* tmp = new Material();
@@ -605,5 +633,7 @@
   sc =  ((unsigned char *)(&lightMapTexture))[i];
   sc *= 1/255.0;
-  scale = 2.0;
+
+  scale = 1.0f; // Adjust brightness here
+
   if(sc > 1.0f && (temp = (1.0f/sc)) < scale) scale=temp;
   scale*=255.0;
Index: trunk/src/lib/graphics/importer/bsp_file.h
===================================================================
--- trunk/src/lib/graphics/importer/bsp_file.h	(revision 8450)
+++ trunk/src/lib/graphics/importer/bsp_file.h	(revision 8490)
@@ -18,4 +18,5 @@
 */
 
+#include <vector>
 class SDL_Surface;
 class BspTreeNode;
@@ -212,5 +213,5 @@
 
  
-
+  ::std::vector<MoviePlayer* > MovieMaterials; //!< Movieplayer Materials
 };
 
